# REST API con Spring Boot, PostgreSQL, JPA

## Puesta en marcha

**1. Clonar aplicación**

```bash
https://github.com/mianso-uoc/dsm_backend.git
```

**2. Crear base de datos postgres**

```bash
create database postgres
```

**3. Actualizar configuración de usuario y password de la base de datos**

+ abrir `src/main/resources/application.properties`

+ cambiar datos `spring.datasource.username` y `spring.datasource.password`

**4. Poner en marcha la aplicación con maven**

```bash
mvn spring-boot:run
```

La aplicación se pondrá en marcha en <http://localhost:8080>.

## APIs REST

Se definen los siguientes métodos:

GET ​/api​/users​/{id}

PUT ​/api​/users​/{id}

DELETE ​/api​/users​/{id}

GET ​/api​/users

POST ​/api​/users

GET ​/api​/users​/type​/{type}


GET ​/api​/products​/{id}

PUT ​/api​/products​/{id}

DELETE ​/api​/products​/{id}

POST ​/api​/products

GET ​/api​/manufacturers​/{manufacturerId}​/products

GET ​/api​/manufacturers​/products​/{id}


GET ​/api​/manufacturers​/{id}

PUT ​/api​/manufacturers​/{id}

DELETE ​/api​/manufacturers​/{id}

GET ​/api​/manufacturers

POST ​/api​/manufacturers


GET ​/api​/machines​/{id}

PUT ​/api​/machines​/{id}

DELETE ​/api​/machines​/{id}

POST ​/api​/machines

GET ​/api​/companies​/{companyId}​/machines

GET ​/api​/companies​/machines​/{id}


PUT ​/api​/issues​/{issueId}​/machine​/{machineId}

DELETE ​/api​/issues​/{issueId}​/machine​/{machineId}

GET ​/api​/issues​/{id}

PUT ​/api​/issues​/{id}

PUT ​/api​/issues​/{id}​/solve

PUT ​/api​/issues​/{id}​/close

GET ​/api​/issues

POST ​/api​/issues

GET ​/api​/issues​/{startDate}​/{endDate}

GET ​/api​/issues​/{startDate}​/{endDate}​/{companyId}

GET ​/api​/issues​/technician​/{technicianId}

GET ​/api​/issues​/company​/{companyId}


GET ​/api​/companies​/{id}

PUT ​/api​/companies​/{id}

DELETE ​/api​/companies​/{id}

GET ​/api​/companies

POST ​/api​/companies


POST ​/api​/issues​/{id}​/documents

GET ​/api​/issues​/{issueId}​/documents

GET ​/api​/documents​/{id}

DELETE ​/api​/documents​/{id}


POST ​/api​/issues​/{id}​/comments

GET ​/api​/comments​/{id}


POST ​/api​/auth​/signin


GET ​/api​/provinces​/{provinceId}​/cities

GET ​/api​/provinces​/{id}

GET ​/api​/provinces​/cities​/{id}

GET ​/api​/countries

GET ​/api​/countries​/{id}

GET ​/api​/countries​/{countryId}​/provinces

GET ​/api​/cities​/{id}
